"use strict";exports.__esModule=true;exports.verifyAndLint=verifyAndLint;var _eslint=require("eslint");var _path=require("path");var _customFormatter=require("./eslint/customFormatter");var _fileExists=require("./file-exists");var log=_interopRequireWildcard(require("../build/output/log"));var _findUp=_interopRequireDefault(require("next/dist/compiled/find-up"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _getRequireWildcardCache(){if(typeof WeakMap!=="function")return null;var cache=new WeakMap();_getRequireWildcardCache=function(){return cache;};return cache;}function _interopRequireWildcard(obj){if(obj&&obj.__esModule){return obj;}if(obj===null||typeof obj!=="object"&&typeof obj!=="function"){return{default:obj};}var cache=_getRequireWildcardCache();if(cache&&cache.has(obj)){return cache.get(obj);}var newObj={};var hasPropertyDescriptor=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var key in obj){if(Object.prototype.hasOwnProperty.call(obj,key)){var desc=hasPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):null;if(desc&&(desc.get||desc.set)){Object.defineProperty(newObj,key,desc);}else{newObj[key]=obj[key];}}}newObj.default=obj;if(cache){cache.set(obj,newObj);}return newObj;}async function verifyAndLint(baseDir,pagesDir,pagePath){let options;let pathNotExists=Boolean(pagePath&&!(await(0,_fileExists.fileExists)((0,_path.join)(pagesDir,pagePath))));if(pathNotExists)return{results:'',hasErrors:false,hasMessages:false};const eslintrcFile=await(0,_findUp.default)(['.eslintrc.js','.eslintrc.yaml','.eslintrc.yml','.eslintrc.json','.eslintrc'],{cwd:baseDir});const pagesDirRules=['@next/next/no-html-link-for-pages'];const pkgJsonPath=await(0,_findUp.default)('package.json',{cwd:baseDir});const{eslintConfig=null}=!!pkgJsonPath?await Promise.resolve(`${pkgJsonPath}`).then(s=>_interopRequireWildcard(require(s))):{};let pluginIsEnabled=false;if(eslintrcFile){options={useEslintrc:true,baseConfig:{}};}else{if(!eslintConfig){console.log();log.info('No ESLint configuration was detected, but checks from the Next.js ESLint plugin were included automatically (see https://nextjs.org/docs/basic-features/eslint).');pluginIsEnabled=true;}options={baseConfig:eslintConfig!=null?eslintConfig:{extends:['plugin:@next/next/recommended'],parser:require.resolve('@babel/eslint-parser'),parserOptions:{requireConfigFile:false,sourceType:'module',babelOptions:{presets:['next/babel']}}},useEslintrc:false};}let eslint=new _eslint.ESLint(options);// check both eslintrc and package.json config since
// eslint will load config from both
for(const configFile of[eslintrcFile,pkgJsonPath]){var _completeConfig$plugi;if(!configFile)continue;const completeConfig=await eslint.calculateConfigForFile(configFile);if((_completeConfig$plugi=completeConfig.plugins)!=null&&_completeConfig$plugi.includes('@next/next')){pluginIsEnabled=true;break;}}if(pluginIsEnabled){let updatedPagesDir=false;for(const rule of pagesDirRules){var _rules,_rules2;if(!((_rules=options.baseConfig.rules)!=null&&_rules[rule])&&!((_rules2=options.baseConfig.rules)!=null&&_rules2[rule.replace('@next/next','@next/babel-plugin-next')])){if(!options.baseConfig.rules){options.baseConfig.rules={};}options.baseConfig.rules[rule]=[1,pagesDir];updatedPagesDir=true;}}if(updatedPagesDir){eslint=new _eslint.ESLint(options);}}else{console.log();log.warn(`The Next.js ESLint plugin was not detected in ${eslintrcFile||pkgJsonPath}. We recommend including it to prevent significant issues in your application (see https://nextjs.org/docs/basic-features/eslint).`);}const results=await eslint.lintFiles([pagePath?(0,_path.join)(pagesDir,pagePath):`${pagesDir}/**/*.{js,tsx}`]);const errors=_eslint.ESLint.getErrorResults(results);return{results:(0,_customFormatter.formatResults)(baseDir,results),hasErrors:(errors==null?void 0:errors.length)>0&&!pagePath,hasMessages:(results==null?void 0:results.length)>0};}
//# sourceMappingURL=verifyAndLint.js.map